// Project imports:
import 'package:zego_uikit/src/plugins/defines.dart';
import 'package:zego_uikit/zego_uikit.dart';

mixin ZegoUIKitUserInRoomAttributesPluginService {
  Future<ZegoSignalingPluginResult> setUsersInRoomAttributes(
    String key,
    String value,
    List<String> userIDs,
  ) async {
    Map result = await ZegoUIKit()
        .getPlugin(ZegoUIKitPluginType.signaling)!
        .invoke('setUsersInRoomAttributes', {
      'key': key,
      'value': value,
      'userIDs': userIDs,
    });

    return ZegoSignalingPluginResult(
      result["errorCode"] as String,
      result["errorMessage"] as String,
      result: result['errorUserList'] as List<String>,
    );
  }

  Future<ZegoSignalingPluginResult> queryUsersInRoomAttributes({
    String nextFlag = '',
    int count = 100,
  }) async {
    Map result = await ZegoUIKit()
        .getPlugin(ZegoUIKitPluginType.signaling)!
        .invoke('queryUsersInRoomAttributes', {
      'nextFlag': nextFlag,
      'count': count,
    });

    return ZegoSignalingPluginResult(
      result["errorCode"] as String,
      result["errorMessage"] as String,
      result: result['infos'] as Map<String, Map<String, String>>,
    );
  }

  Stream<Map> getUsersInRoomAttributesStream() {
    return ZegoUIKit()
        .getPlugin(ZegoUIKitPluginType.signaling)!
        .getEventStream('usersInRoomAttributes');
  }
}
